#if !defined __TRUETYPEOUTLINE_H__
#define __TRUETYPEOUTLINE_H__

#ifdef WIN32
class TrueTypeOutline
{
public:
	double m_dScale;           // for scaling the glyph
	double m_xExtent;
	double m_yExtent;
	double m_zExtent;
	double m_dMeshSize;

public:
	TrueTypeOutline();
	~TrueTypeOutline();

	double GetAngle();
	void GetBoundingRect( RECT * const prect,   const int xOffset = 0,  const int yOffset = 0 ) const;
	bool IsRealized() const;
	bool Realize();
	bool Realize(  const UINT uChar);

	void GetOutline(const int xOffset, const int yOffset, std::vector<int>& types, std::vector<POINT>& pnts) const;
	void SetAngle(const double dNewValue);
	void Unrealize();
	int SetGlyphFontByDialog();

	GLYPHMETRICS m_gm;         // glyph measurements from GetGlyphOutline
protected:
	bool m_bRealized; 
	DWORD m_cbBuffer;          // size of m_lpvBuffer
	double m_dAngleDegrees;    // angle by which to rotate glyph
	LPVOID m_lpvBuffer;        // curve data from GetGlyphOutline
	MAT2 m_mat2;               // transformation matrix for GetGlyphOutline
	UINT m_uChar;              // character to render
	UINT m_format;
	LOGFONT m_lf;          // keeps track of current font properties

protected:
	inline void FromGGOPoint(POINT * const ppt,	const int xGGO,		const int yGGO, 	const int xOffset = 0,	const int yOffset = 0	) const;
	inline void FromGGOPoint(POINT * const ppt,  	const POINTFX & ptfxGGO, 	const int xOffset = 0, 	const int yOffset = 0	) const;
	void FromGGORect(RECT * const prect,	const int nGGOLeft, const int nGGOTop,	const int nGGORight,	const int nGGOBottom,
		const int xOffset = 0,  const int yOffset = 0) const;
	void MakeRotationMatrix();
	void ReselectOldFont(const HDC hDC,  const HFONT hOldFont,  const HFONT hFont );

};
#endif
#endif
